<app-marketing-frame
  headline="Regain peace of mind for your passwords"
  tagline="Remember the backup code you saved or printed when you signed up? Here’s where you&nbsp;use&nbsp;it."
>
  <div class="account-column__inner account-column__inner--right">
    <div class="account-column__right-heading">
      <h1 class="heading-medium">Reset&nbsp;Password</h1>
      <div class="account-column__link">
        <app-text-link id="btn-signin" [link]="['/account/login']">
          Back to Login
        </app-text-link>
      </div>
    </div>

    <div class="register-step__heading--completed u-margin-b-20">
      Email
      <span
        class="register-step__icon register-step__icon--active"
        [inlineSVG]="'../../assets/svg/check.svg'"
      ></span>
    </div>

    <div class="register-step__heading--completed u-margin-b-20">
      Confirm Email Address
      <span
        class="register-step__icon register-step__icon--active"
        [inlineSVG]="'../../assets/svg/check.svg'"
      ></span>
    </div>

    <div class="form-field form-field--large">
      <div class="form-field__label">Enter Backup Code</div>
      <p class="register-step__feedback">
        When you signed up for your account, you were given the option to print
        or save a PDF file that contained your backup code. Pull that up and
        either scan the QR code or enter the 32-character code below.
      </p>
    </div>

    <app-non-field-messages
      *ngIf="errorMessage || localErrorMessage"
      [messages]="[errorMessage, localErrorMessage]"
    ></app-non-field-messages>

    <div class="u-margin-b-20" *ngIf="!cameraError">
      <button
        id="scan-qr-button"
        (click)="toggleScan()"
        class="button button--primary"
      >
        Scan QR Code
      </button>
      <span class="text-next-to-button u-margin-l-20">or</span>
    </div>

    <div [class.u-invisible]="!showScanner" class="canvas-check-wrapper">
      <canvas #canvas id="canvas" class="canvas"></canvas>

      <div
        class="close-wrapper"
        *ngIf="showQuitButton && !hasStarted"
        (click)="toggleScan()"
      >
        <div class="close-circle">
          <div
            class="close-icon"
            [inlineSVG]="'../../assets/svg/plus.svg'"
          ></div>
        </div>
      </div>

      <div class="check-wrapper">
        <div class="verified-circle" *ngIf="hasStarted">
          <div
            class="checkmark-icon"
            [inlineSVG]="'../../assets/svg/check.svg'"
          ></div>
        </div>
      </div>
    </div>

    <form [ngrxFormState]="form" (submit)="onSubmit()">
      <div class="form-field form-field--large u-margin-t-15">
        <ul class="form-field__error-list">
          <li class="form-field__error">{{ cameraError }}</li>
        </ul>
        <label [for]="form.controls.code.id" class="form-field__label">
          Type Backup Code
        </label>
        <input
          type="text"
          [ngrxFormControlState]="form.controls.code"
          autofocus
          spellcheck="false"
          class="form-field__input"
          [class.form-field__input--invalid]="
            form.errors._code && form.isSubmitted
          "
        />
      </div>
      <ul *ngIf="badCodeError" class="form-field__error-list">
        <li class="form-field__error">{{ badCodeError }}</li>
      </ul>
      <ul
        *ngIf="form.errors._code && form.isSubmitted"
        class="form-field__error-list"
      >
        <li *ngIf="form.errors._code.required" class="form-field__error">
          You must enter your backup code.
        </li>
        <li *ngIf="form.errors._code.minLength" class="form-field__error">
          Your backup code must be 32 characters long.
        </li>
      </ul>
      <div class="verify-backup-code__actions">
        <button
          id="loginSubmit"
          class="button button--primary"
          [disabled]="hasStarted"
          type="submit"
        >
          Next
        </button>
        <progress-indicator
          [inProgress]="hasStarted"
          inProgressText="Submitting Code"
        ></progress-indicator>
      </div>
    </form>

    <div class="register-step__heading--inactive u-margin-t-20">
      Enter New Password
    </div>
  </div>
</app-marketing-frame>
